setup-disk.in 27.5 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5
#!/bin/sh

PREFIX=
. "$PREFIX/lib/libalpine.sh"

6
MBR=${MBR:-"/usr/share/syslinux/mbr.bin"}
7 8
ROOTFS=${ROOTFS:-ext4}
BOOTFS=${BOOTFS:-ext4}
9
VARFS=${VARFS:-ext4}
Natanael Copa's avatar
Natanael Copa committed
10

11 12 13
# default location for mounted root
SYSROOT=${SYSROOT:-/mnt}

14 15 16
# machine arch
ARCH=$(apk --print-arch)

Natanael Copa's avatar
Natanael Copa committed
17 18 19 20 21 22 23 24 25 26
in_list() {
	local i="$1"
	shift
	while [ $# -gt 0 ]; do
		[ "$i" = "$1" ] && return 0
		shift
	done
	return 1
}

27 28 29 30 31 32 33 34 35 36 37
all_in_list() {
	local needle="$1"
	local i
	[ -z "$needle" ] && return 1
	shift
	for i in $needle; do
		in_list "$i" $@ || return 1
	done
	return 0
}

38 39 40 41 42 43 44 45
# wrapper to only show given device
_blkid() {
	blkid | grep "^$1:"
}

# if given device have an UUID display it, otherwise return the device
uuid_or_device() {
	local i=
46 47 48
	case "$1" in
		/dev/md*) echo "$1" && return 0;;
	esac
49 50 51 52 53 54 55 56 57 58 59 60 61
	for i in $(_blkid "$1"); do
		case "$i" in
			UUID=*) eval $i;;
		esac
	done
	if [ -n "$UUID" ]; then
		echo "UUID=$UUID"
	else
		echo "$1"
	fi
}

# generate an fstab from a given mountpoint. Convert to UUID if possible
62
enumerate_fstab() {
63
	local mnt="$1"
64
	local fs_spec= fs_file= fs_vfstype= fs_mntops= fs_freq= fs_passno=
65
	[ -z "$mnt" ] && return
66 67
	local escaped_mnt=$(echo $mnt | sed -e 's:/*$::' -e 's:/:\\/:g')
	awk "\$2 ~ /^$escaped_mnt(\/|\$)/ {print \$0}" /proc/mounts | \
68
		sed "s:$mnt:/:g; s: :\t:g" | sed -E 's:/+:/:g' | \
69
		while read fs_spec fs_file fs_vfstype fs_mntops fs_freq fs_passno; do
70 71 72 73 74
			if [ "$fs_file" = / ]; then
				fs_passno=1
			else
				fs_passno=2
			fi
75 76
			echo -e "$(uuid_or_device $fs_spec)\t${fs_file}\t${fs_vfstype}\t${fs_mntops} ${fs_freq} ${fs_passno}"
		done
77 78
}

79 80 81 82 83
is_vmware() {
	grep -q VMware /proc/scsi/scsi 2>/dev/null \
		|| grep -q VMware /proc/ide/hd*/model 2>/dev/null
}

84 85 86 87 88
# return true (0) if given device is lvm
is_lvm() {
	lvs "$1" >/dev/null 2>&1
}

89 90
# Find the disk device from given partition
disk_from_part() {
91 92
	# we need convert cciss/c0d0* cciss!c0d0*...
	local i= part=$(echo ${1#/dev/} | sed 's:/:!:g')
93 94
	for i in /sys/block/*/$part; do
		i=${i%/*}
95
		# ...and back from cciss!c0d0 to cciss/c0d0
96 97 98 99
		if [ -b "/dev/${i##*/}" ]; then
			echo "/dev/${i##*/}" | sed 's:!:/:g'
			return 0
		fi
100 101 102 103
	done
	return 1
}

104 105 106 107 108 109 110 111 112 113 114 115 116 117
unpack_apkovl() {
	local ovl="$1"
	local dest="$2"
	local suffix=${ovl##*.}
	local i
	ovlfiles=/tmp/ovlfiles
	if [ "$suffix" = "gz" ]; then
		if ! tar -C "$dest" --numeric-owner -zxvf "$ovl" > $ovlfiles; then
			echo -n "Continue anyway? [Y/n]: "
			read i
			case "$i" in
				n*|N*) return 1;;
			esac
		fi
118
		return 0
119 120
	fi

121
	apk add --quiet openssl
122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138

	if ! openssl list-cipher-commands | grep "^$suffix$" > /dev/null; then
		errstr="Cipher $suffix is not supported"
		return 1
	fi
	local count=0
	# beep
	echo -e "\007"
	while [ $count -lt 3 ]; do
		openssl enc -d -$suffix -in "$ovl" | tar --numeric-owner \
			-C "$dest" -zxv >$ovlfiles 2>/dev/null && return 0
		count=$(( $count + 1 ))
	done
	ovlfiles=
	return 1
}

139 140 141 142 143 144 145 146
# find filesystem of given mounted dir
find_mount_fs() {
	local mount_point="$1"
	awk "\$2 == \"$mount_point\" {print \$3}" /proc/mounts | tail -n 1
}

# find device for given mounted dir
find_mount_dev() {
147
	local mnt="$1"
148 149 150 151
	awk "\$2 == \"$mnt\" { print \$1 }" /proc/mounts | tail -n 1
}

supported_boot_fs() {
152
	local supported="ext2 ext3 ext4 btrfs xfs"
153 154 155 156 157 158 159 160
	local fs=
	for fs in $supported; do
		[ "$fs" = "$1" ] && return 0
	done
	echo "$1 is not supported. Only supported are: $supported" >&2
	return 1
}

161 162
find_volume_group() {
	local lv=${1##*/}
163
	lvs --noheadings "$1" | awk '{print $2}'
164 165 166 167 168 169 170
}

find_pvs_in_vg() {
	local vg="$1"
	pvs --noheadings | awk "\$2 == \"$vg\" {print \$1}"
}

171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195
# echo current grsecurity option and set new
set_grsec() {
	local key="$1" value="$2"
	if ! [ -e /proc/sys/kernel/grsecurity/$key ]; then
		return 0
	fi
	cat /proc/sys/kernel/grsecurity/$key
	echo $value > /proc/sys/kernel/grsecurity/$key
}

init_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		mkdir -p "$mnt"/$i
		mount --bind /$i "$mnt"/$i
	done
}

cleanup_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		umount "$mnt"/$i
	done
}

196 197 198 199 200 201 202 203 204
has_bootopt() {
	local opt="$1"
	set -- $(cat /proc/cmdline)
	for i; do
		[ "$i" = "$opt" ] && return 0
	done
	return 1
}

205 206
# setup grub bootloader
setup_grub() {
207 208
	local mnt="$1" root="$2" modules="$3" kernel_opts="$4"
	shift 4
209 210 211 212 213 214 215 216 217 218 219 220
	local disks="${@}"

	for disk in $disks; do
		# install grub
		prep=$(find_prep_partition $disk)
		echo "Installing grub on $prep"
		grub-install --boot-directory="$mnt"/boot/ $prep
	done
	# create grub config
	cat > "$mnt"/boot/grub/grub.cfg  <<- EOF
	set timeout=2
	menuentry "Alpine Linux" {
221
		linux   /boot/vmlinuz $modules root=$root $kernel_opts
222 223 224 225 226 227 228
		initrd  /boot/initramfs-$KERNEL_FLAVOR
	}
	EOF
}

# setup syslinux bootloader
setup_syslinux() {
229 230
	local mnt="$1" root="$2" modules="$3" kernel_opts="$4" bootdev="$5"
	local exlinux_raidopt=
231 232 233 234 235 236 237 238 239

	sed -e "s:^root=.*:root=$root:" \
		-e "s:^default_kernel_opts=.*:default_kernel_opts=\"$kernel_opts\":" \
		-e "s:^modules=.*:modules=$modules:" \
		/etc/update-extlinux.conf > "$mnt"/etc/update-extlinux.conf
	if [ "$(rc --sys)" = "XEN0" ]; then
		sed -i -e "s:^default=.*:default=xen-grsec:" \
			"$mnt"/etc/update-extlinux.conf
	fi
240 241 242 243 244 245 246

	# Check if we boot from raid so we can pass proper option to
	# extlinux later.
	if [ -e "/sys/block/${bootdev#/dev/}/md" ]; then
		extlinux_raidopt="--raid"
	fi

247 248 249
	extlinux $extlinux_raidopt --install "$mnt"/boot
}

250
install_mounted_root() {
251 252 253
	local mnt="$1"
	shift 1
	local disks="${@}" mnt_boot= boot_fs= root_fs=
254
	local initfs_features="ata base cdrom ext2 ext3 ext4 keymap kms mmc raid scsi usb virtio nvme"
255
	local pvs= dev= rootdev= bootdev= extlinux_raidopt= root= modules=
256
	local kernel_opts="quiet"
257

258
	rootdev=$(find_mount_dev "$mnt")
259 260 261 262
	if [ -z "$rootdev" ]; then
		echo "$mnt does not seem to be a mount point" >&2
		return 1
	fi
263
	root_fs=$(find_mount_fs "$mnt")
264 265 266 267
	initfs_features="$initfs_features $root_fs"

	if is_lvm "$rootdev"; then
		initfs_features="$initfs_features lvm"
268 269
		local vg=$(find_volume_group "$rootdev")
		pvs=$(find_pvs_in_vg $vg)
270 271
	fi

272

273 274 275
	bootdev=$(find_mount_dev "$mnt"/boot)
	if [ -z "$bootdev" ]; then
		bootdev=$rootdev
276
		mnt_boot="$mnt"
277 278 279 280 281 282
	else
		mnt_boot="$mnt"/boot
	fi
	boot_fs=$(find_mount_fs "$mnt_boot")
	supported_boot_fs "$boot_fs" || return 1

283
	# check if our root is on raid so we can feed mkinitfs and
284
	# bootloader conf with the proper kernel module params
285
	for dev in $rootdev $pvs; do
286 287 288 289 290 291 292 293

		# check if we need hardware raid drivers
		case $dev in
		/dev/cciss/*)
			initfs_features="${initfs_features% raid} raid"
			;;
		esac

294 295 296
		[ -e "/sys/block/${dev#/dev/}/md" ] || continue

		local md=${dev#/dev/}
297
		initfs_features="${initfs_features% raid} raid"
298 299
		local level=$(cat /sys/block/$md/md/level)
		case "$level" in
300 301
			raid1) raidmod="${raidmod%,raid1},raid1";;
			raid[456]) raidmod="${raidmod%,raid456},raid456";;
302 303
		esac
	done
304 305


306 307 308 309 310 311
	if [ -n "$VERBOSE" ]; then
		echo "Root device:     $rootdev"
		echo "Root filesystem: $root_fs"
		echo "Boot device:     $bootdev"
		echo "Boot filesystem: $boot_fs"
	fi
312

313
	if [ -z "$APKOVL" ]; then
314 315
		ovlfiles=/tmp/ovlfiles
		lbu package - | tar -C "$mnt" -zxv > "$ovlfiles"
316 317 318 319
		# comment out local repositories
		if [ -f "$mnt"/etc/apk/repositories ]; then
			sed -i -e 's:^/:#/:' "$mnt"/etc/apk/repositories
		fi
320 321
	else
		echo "Restoring backup from $APKOVL to $rootdev..."
322
		unpack_apkovl "$APKOVL" "$mnt" || return 1
323
	fi
324

325 326 327
	# we should not try start modloop on sys install
	rm -f "$mnt"/etc/runlevels/*/modloop

328
	# generate mkinitfs.conf
329
	mkdir -p "$mnt"/etc/mkinitfs/features.d
330
	echo "features=\"$initfs_features\"" > "$mnt"/etc/mkinitfs/mkinitfs.conf
331
	if [ -n "$raidmod" ]; then
332 333
		echo "/sbin/mdadm" > "$mnt"/etc/mkinitfs/features.d/raid.files
		echo "/etc/mdadm.conf" >> "$mnt"/etc/mkinitfs/features.d/raid.files
334
	fi
335

336 337
	# generate update-extlinux.conf
	root=$(uuid_or_device $rootdev)
338
	kernel_opts="$kernel_opts rootfstype=$root_fs"
339 340 341
	if is_vmware; then
		kernel_opts="pax_nouderef $kernel_opts"
	fi
342 343 344
	if has_bootopt nomodeset; then
		kernel_opts="nomodeset $kernel_opts"
	fi
345 346
	modules="sd-mod,usb-storage,${root_fs}${raidmod}"

347 348 349 350 351
	# generate the fstab
	if [ -f "$mnt"/etc/fstab ]; then
		mv "$mnt"/etc/fstab "$mnt"/etc/fstab.old
	fi
	enumerate_fstab "$mnt" >> "$mnt"/etc/fstab
352 353 354 355
	if [ -n "$SWAP_DEVICE" ]; then
		echo -e "${SWAP_DEVICE}\tswap\tswap\tdefaults\t0 0" \
			>> "$mnt"/etc/fstab
	fi
356 357 358 359 360
	cat >>"$mnt"/etc/fstab <<-__EOF__
		/dev/cdrom	/media/cdrom	iso9660	noauto,ro 0 0
		/dev/fd0	/media/floppy	vfat	noauto	0 0
		/dev/usbdisk	/media/usb	vfat	noauto	0 0
	__EOF__
361
	# remove the installed db in case its there so we force re-install
362
	rm -f "$mnt"/var/lib/apk/installed "$mnt"/lib/apk/db/installed
363
	echo "Installing system on $rootdev:"
364
	case "$ARCH" in
365 366
                ppc64le) setup_grub "$mnt" "$root" "$modules" "$kernel_opts" $disks;;
                *) setup_syslinux "$mnt" "$root" "$modules" "$kernel_opts" "$bootdev";;
367
        esac
368

369 370 371 372
	# apk reads config from target root so we need to copy the config
	mkdir -p "$mnt"/etc/apk/keys/
	cp /etc/apk/keys/* "$mnt"/etc/apk/keys/

373
	local apkflags="--initdb --quiet --progress --update-cache --clean-protected"
374 375 376
	local pkgs=$(grep -h -v -w sfdisk "$mnt"/etc/apk/world \
		"$mnt"/var/lib/apk/world 2>/dev/null)

377
	pkgs="$pkgs acct linux-$KERNEL_FLAVOR alpine-base"
378 379 380
	if [ "$(rc --sys)" = "XEN0" ]; then
		pkgs="$pkgs xen-hypervisor"
	fi
381 382 383 384 385
	local repos=$(sed -e 's/\#.*//' /etc/apk/repositories)
	local repoflags=
	for i in $repos; do
		repoflags="$repoflags --repository $i"
	done
386

387 388
	chroot_caps=$(set_grsec chroot_caps 0)
	init_chroot_mounts "$mnt"
389
	apk add --root "$mnt" $apkflags --overlay-from-stdin \
Natanael Copa's avatar
Natanael Copa committed
390
		$repoflags $pkgs <$ovlfiles
391 392 393 394
	local ret=$?
	cleanup_chroot_mounts "$mnt"
	set_grsec chroot_caps $chroot_caps > /dev/null
	return $ret
395 396 397 398
}

unmount_partitions() {
	local mnt="$1"
399 400

	# unmount the partitions
401
	umount $(awk '{print $2}' /proc/mounts | egrep "^$mnt(/|\$)" | sort -r)
402
}
403

404 405 406
# figure out decent default swap size in mega bytes
find_swap_size() {
	local memtotal_kb=$(awk '$1 == "MemTotal:" {print $2}' /proc/meminfo)
407 408 409 410
	# use 2 * avaiable ram or no more than 1/3 of smallest disk space
	local size=$(( $memtotal_kb * 2 / 1024 ))
	local disk= disksize=
	for disk in $@; do
411 412
		local sysfsdev=$(echo ${disk#/dev/} | sed 's:/:!:g')
		local sysfspath=/sys/block/$sysfsdev/size
413 414 415 416 417 418 419 420 421 422 423 424 425 426 427
		# disksize = x * 512 / (1024 * 1024) = x / 2048
		# maxsize = $disksize / 4 = x / (2048 * 4) = x / 8192
		maxsize=$(awk '{ printf "%i", $0 / 8192 }' $sysfspath )
		if [ $size -gt $maxsize ]; then
			size=$maxsize
		fi
	done
	if [ $size -gt 4096 ]; then
		# dont ever use more than 4G
		size=4096
	elif [ $size -lt 64 ]; then
		# dont bother create swap smaller than 64MB
		size=0
	fi
	echo $size
428 429 430 431
}

has_mounted_part() {
	local p
432
	local sysfsdev=$(echo ${1#/dev/} | sed 's:/:!:g')
Natanael Copa's avatar
Natanael Copa committed
433
	# parse /proc/mounts for mounted devices
434
	for p in $(awk '$1 ~ /^\/dev\// {gsub("/dev/", "", $1); gsub("/", "!", $1); print $1}' \
435
			/proc/mounts); do
436 437
		[ "$p" = "$sysfsdev" ] && return 0
		[ -e /sys/block/$sysfsdev/$p ] && return 0
438 439 440 441
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
442 443 444 445 446 447 448 449 450 451 452 453 454 455 456
has_holders() {
	local i
	# check if device is used by any md devices
	for i in $1/holders/* $1/*/holders/*; do
		[ -e "$i" ] && return 0
	done
	return 1
}

is_available_disk() {
	local dev=$1
	local b=$(echo $p | sed 's:/:!:g')

	# check if its a "root" block device and not a partition
	[ -e /sys/block/$b ] || return 1
457

Natanael Copa's avatar
Natanael Copa committed
458 459 460 461
	# check so it does not have mounted partitions
	has_mounted_part $dev && return 1

	# check so its not part of an md setup
462 463 464 465
	if has_holders /sys/block/$b; then
		[ -n "$USE_RAID" ] && echo "Warning: $dev is part of a running raid" >&2
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
466 467 468 469 470 471 472

	# check so its not an md device
	[ -e /sys/block/$b/md ] && return 1

	return 0
}

473
find_disks() {
Natanael Copa's avatar
Natanael Copa committed
474
	local p=
475 476
	# filter out ramdisks (major=1)
	for p in $(awk '$1 != 1 && $1 ~ /[0-9]+/ {print $4}' /proc/partitions); do
Natanael Copa's avatar
Natanael Copa committed
477
		is_available_disk $p && echo -n " $p"
478 479 480
	done
}

481 482 483 484 485 486 487 488 489
stop_all_raid() {
	local rd
	for rd in /dev/md*; do
		[ -b $rd ] && mdadm --stop $rd
	done
}

# install needed programs
init_progs() {
490
	local raidpkg= lvmpkg= fs= fstools=
491
	[ -n "$USE_RAID" ] && raidpkg="mdadm"
492
	[ -n "$USE_LVM" ] && lvmpkg="lvm2"
493 494 495
	for fs in $BOOTFS $ROOTFS $VARFS; do
		# we need load btrfs module early to avoid the error message:
		# 'failed to open /dev/btrfs-control'
496 497 498
		if ! grep -q -w "$fs" /proc/filesystems; then
			modprobe $fs
		fi
499 500 501 502 503

		case $fs in
		xfs) fstools="$fstools xfsprogs";;
		ext*) fstools="$fstools e2fsprogs";;
		btrfs) fstools="$fstools btrfs-progs";;
504 505
		esac
	done
506
	apk add --quiet sfdisk $lvmpkg $raidpkg $fstools $@
507 508
}

509
show_disk_info() {
Natanael Copa's avatar
Natanael Copa committed
510
	local disk= vendor= model= d= size=
511
	for disk in $@; do
512 513
		local dev=${disk#/dev/}
		d=$(echo $dev | sed 's:/:!:g')
514 515 516
		vendor=$(cat /sys/block/$d/device/vendor 2>/dev/null)
		model=$(cat /sys/block/$d/device/model 2>/dev/null)
		size=$(awk '{gb = ($1 * 512)/1000000000; printf "%.1f GB\n", gb}' /sys/block/$d/size 2>/dev/null)
517
		echo "  $dev	($size $vendor $model)"
518 519
	done
}
520

521 522
confirm_erase() {
	local answer=
523 524
	local erasedisks="$@"
	if [ "$ERASE_DISKS" = "$erasedisks" ]; then
Natanael Copa's avatar
Natanael Copa committed
525
		return 0
526
	fi
527
	echo "WARNING: The following disk(s) will be erased:"
528
	show_disk_info $@
529
	echo -n "WARNING: Erase the above disk(s) and continue? [y/N]: "
530

531 532
	read answer
	case "$answer" in
533
		y*|Y*) return 0;;
534
	esac
535
	return 1
536 537
}

538
# setup partitions on given disk dev in $1.
539
# usage: setup_partitions <diskdev> size1,type1 [size2,type2 ...]
540 541 542 543 544
setup_partitions() {
	local diskdev="$1"
	shift

	echo "Initializing partitions on $diskdev..."
545 546 547 548 549 550 551

	# new disks does not have an DOS signature in sector 0
	# this makes sfdisk complain. We can workaround this by letting
	# fdisk create that DOS signature, by just do a "w", a write.
	# http://bugs.alpinelinux.org/issues/show/145
	echo "w" | fdisk $diskdev >/dev/null

552
	# fix the MBR while here so extlinux can boot
553 554 555
	if [ -f "$MBR" ]; then
		cat "$MBR" > $diskdev
	fi
556

557
	local start=1M
558
	local line=
559 560
	# create new partitions
	(
561 562 563 564
		for line in "$@"; do
			echo "$start,$line"
			start=
		done
565
	) | sfdisk --quiet $diskdev >/dev/null || return 1
566 567 568 569 570 571 572 573 574 575

	# create device nodes if not exist
	mdev -s
}

# find the bootable partition on given disk
find_boot_partition() {
	sfdisk -d $1 | awk '/bootable/ {print $1}'
}

576 577 578 579 580
# find partition from PReP type on given disk
find_prep_partition() {
	sfdisk -d $1 | awk '/type=41/ {print $1}'
}

581
# find the partition(s) for LVM
582
# this is not marked as bootable and is type 8e
583 584
find_lvm_partition() {
	local type=8e
585
	sfdisk -d $1 | grep -v bootable | awk "/(Id|type)=$type/ {print \$1}"
586 587
}

588
# set up optional raid and create filesystem on boot device.
589
setup_boot_dev() {
590 591
	local disks="$@" disk= bootdev= mkfs_args="-q"
	local part=$(for disk in $disks; do find_boot_partition $disk; done)
592 593
	set -- $part
	bootdev=$1
594
	[ -z "$bootdev" ] && return 1
595 596 597 598 599 600 601 602 603 604

	if [ "$ARCH" = "ppc64le" ]; then
		# Change bootable partition to PReP partition
		for disk in $disks; do
			echo ',,,*' | sfdisk --quiet $disk -N1
			echo ',,,-' | sfdisk --quiet $disk -N2
			mdev -s
		done
	fi

605
	echo "Creating file systems..."
606
	if [ -n "$USE_RAID" ]; then
607 608 609 610 611 612
		local missing=
		local num=$#
		if [ $# -eq 1 ]; then
			missing="missing"
			num=2
		fi
613
		# we only use raid level 1 for boot devices
614 615
		mdadm --create /dev/md0 --level=1 --raid-devices=$num \
			--metadata=0.90 --quiet --run $@ $missing || return 1
616 617
		bootdev=/dev/md0
	fi
618 619 620 621
	case "$BOOTFS" in
	btrfs) mkfs_args="";;
	ext4) mkfs_args="$mkfs_args -O ^64bit";; # pv-grub does not support 64bit
	esac
622
	mkfs.$BOOTFS $MKFS_OPTS_BOOT $mkfs_args $bootdev
623 624 625 626
	BOOT_DEV="$bootdev"
}

# $1 = index
627 628 629
# $2 = partition type
# $3... = disk devices
find_nth_non_boot_parts() {
630
	local idx=$1
631
	local id=$2
632 633
	local disk=
	shift
634
	shift
635 636
	for disk in $@; do
		sfdisk -d $disk | grep -v bootable \
637
			| awk "/(Id|type)=$id/ { i++; if (i==$idx) print \$1 }"
638 639 640 641 642 643
	done
}

setup_non_boot_raid_dev() {
	local md_dev=$1
	local idx=${md_dev#/dev/md}
644 645 646 647 648
	if [ "$ARCH" = "ppc64le" ]; then
		# increment idx as PReP partition is
		# the bootable partition in ppc64le
		idx=$((idx+1))
	fi
649 650 651
	shift
	local level=1
	local missing=
652
	local raid_parts=$(find_nth_non_boot_parts $idx "fd" $@)
653 654 655 656 657 658 659 660
	set -- $raid_parts
	# how many disks do we have?
	case $# in
		0) echo "No Raid partitions found" >&2; return 1;;
		1) level=1; missing="missing"; num=2;;
		2) level=1; missing=  ; num=2;;
		*) level=5; missing=  ; num=$#;;
	esac
661
	mdadm --create $md_dev --level=$level --raid-devices=$num \
662
		--quiet --run $@ $missing || return 1
663 664 665 666
}

# setup device for lvm, create raid array if needed
setup_lvm_volume_group() {
667 668 669
	local vgname="$1"
	shift
	local lvmdev=
670 671

	if [ -n "$USE_RAID" ]; then
672 673
		setup_non_boot_raid_dev /dev/md1 $@ || return 1
		lvmdev=/dev/md1
674
	else
675
		lvmdev=$(find_lvm_partition $1)
676 677 678 679 680
	fi

	# be quiet on success
	local errmsg=$(dd if=/dev/zero of=$lvmdev bs=1k count=1 2>&1) \
		|| echo "$errmsg"
681 682 683 684 685 686 687 688 689 690 691 692
	pvcreate --quiet $lvmdev \
		&& vgcreate --quiet $vgname $lvmdev >/dev/null
}

# set up swap on given device(s)
setup_swap_dev() {
	local swap_dev=
	sed -i -e '/swap/d' /etc/fstab
	for swap_dev in "$@"; do
		mkswap $swap_dev >/dev/null
		echo -e "$swap_dev\tswap\t\tswap\tdefaults 0 0" >> /etc/fstab
	done
693
	SWAP_DEVICE="$(uuid_or_device $swap_dev)"
694 695
	swapon -a
	rc-update --quiet add swap boot
696 697 698
}

# setup and enable swap on given volumegroup if needed
699
setup_lvm_swap() {
700
	local vgname="$1"
701
	local swapname=lv_swap
702 703 704
	if [ -z "$SWAP_SIZE" ] || [ "$SWAP_SIZE" -eq 0 ]; then
		return
	fi
705 706
	lvcreate --quiet -n $swapname -L ${SWAP_SIZE}MB $vgname
	setup_swap_dev /dev/$vgname/$swapname
707 708 709 710 711 712 713 714 715 716
}

# if /var is mounted, move out data and umount it
reset_var() {
	[ -z "$(find_mount_dev /var)" ] && return 0
	mkdir /.var
	mv /var/* /.var/ 2>/dev/null
	umount /var && 	rm -rf /var && mv /.var /var && rm -rf /var/lost+found
}

717 718 719
# set up /var on given device
setup_var() {
	local var_dev="$1"
720
	local varfs=${VARFS}
721
	echo "Creating file systems..."
722
	mkfs.$varfs $MKFS_OPTS_VAR $var_dev >/dev/null || return 1
723 724 725 726 727 728 729 730 731
	sed -i -e '/[[:space:]]\/var[[:space:]]/d' /etc/fstab
	echo -e "${var_dev}\t/var\t\t${varfs}\tdefaults 1 2" >> /etc/fstab

	mv /var /.var
	mkdir /var
	mount /var
	mv /.var/* /var/
	rmdir /.var

732
	service syslog --quiet condrestart
733
	setup_mdadm_conf
734 735
}

736
setup_mdadm_conf() {
737
	local mods= mod=
738 739 740
	if [ -n "$USE_RAID" ]; then
		mdadm --detail --scan > /etc/mdadm.conf
		rc-update --quiet add mdadm-raid boot
741 742 743 744 745 746
		mods=$(awk '/^raid/ {print $1}' /proc/modules)
		for mod in $mods; do
			if ! grep -q "^$mod" /etc/modules; then
				echo $mod >> /etc/modules
			fi
		done
747 748 749
	fi
}

750
data_only_disk_install_lvm() {
751
	local diskdev=
752 753
	local vgname=vg0
	local var_dev=/dev/$vgname/lv_var
754 755 756
	local lvm_part_type="8e"
	local part_type=$lvm_part_type
	local size=
757 758

	init_progs || return 1
759
	confirm_erase $@ || return 1
760

761
	if [ "$USE_RAID" ]; then
762 763
		# the paritition type for raid is "fd"
		part_type="fd"
764 765
		stop_all_raid
	fi
766

767
	for diskdev in "$@"; do
768
		setup_partitions $diskdev "${size}${size:+M},$part_type" || return 1
769
	done
770

771 772
	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
773
	lvcreate --quiet -n ${var_dev##*/} -l 100%FREE $vgname
774
	setup_mdadm_conf
Natanael Copa's avatar
Natanael Copa committed
775
	rc-update add lvm boot
776
	setup_var $var_dev
777 778
}

779 780
data_only_disk_install() {
	local diskdev=
781 782
	local var_dev=
	local var_part_type="83"
783 784 785 786 787 788 789 790 791 792 793 794 795 796 797
	local swap_part_type=82
	local size=
	local swap_dev= var_dev=

	init_progs || return 1
	confirm_erase $@ || return 1

	if [ "$USE_RAID" ]; then
		var_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi

	for diskdev in "$@"; do
		setup_partitions $diskdev \
798 799
			"${SWAP_SIZE}M,$swap_part_type" \
			"${size}${size:+M},$var_part_type" || return 1
800 801 802 803 804 805 806 807 808 809 810 811 812 813 814
	done

	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		var_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		var_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_var $var_dev
}

815
# setup
816
setup_root() {
817 818 819
	local root_dev="$1" boot_dev="$2"
	shift 2
	local disks="$@" mkfs_args="-q"
Natanael Copa's avatar
Natanael Copa committed
820
	[ "$ROOTFS" = "btrfs" ] && mkfs_args=""
821
	mkfs.$ROOTFS $MKFS_OPTS_ROOT $mkfs_args "$root_dev"
822 823
	mkdir -p "$SYSROOT"
	mount -t $ROOTFS $root_dev "$SYSROOT" || return 1
824
	if [ -n "$boot_dev" ]; then
825 826
		mkdir -p "$SYSROOT"/boot
		mount -t $BOOTFS $boot_dev "$SYSROOT"/boot || return 1
827 828 829
	fi

	setup_mdadm_conf
830
	install_mounted_root "$SYSROOT" "$disks" || return 1
831
	unmount_partitions "$SYSROOT"
832 833 834
	swapoff -a

	echo ""
835
	echo "Installation is complete. Please reboot."
836 837
}

838
native_disk_install_lvm() {
839 840 841 842 843 844 845
	local diskdev= vgname=vg0
	local lvm_part_type="8e"
	local boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local lvm_size=
	local root_dev=/dev/$vgname/lv_root

846
	init_progs syslinux || return 1
847
	confirm_erase $@ || return 1
848 849

	if [ -n "$USE_RAID" ]; then
850 851 852
		boot_part_type="fd"
		lvm_part_type="fd"
		stop_all_raid
853
	fi
854 855
	for diskdev in "$@"; do
		setup_partitions $diskdev \
856 857
			"${boot_size}M,$boot_part_type,*" \
			"${lvm_size}${lvm_size:+M},$lvm_part_type" || return 1
858 859 860 861 862 863 864 865
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@

	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
	lvcreate --quiet -n ${root_dev##*/} -l 100%FREE $vgname
Natanael Copa's avatar
Natanael Copa committed
866
	rc-update add lvm boot
867
	setup_root $root_dev $BOOT_DEV
Natanael Copa's avatar
Natanael Copa committed
868 869
}

870
native_disk_install() {
871 872
	local prep_part_type="41" root_part_type="83" swap_part_type="82" boot_part_type="83"
	local prep_size=8
873 874 875 876
	local boot_size=${BOOT_SIZE:-100}
	local swap_size=${SWAP_SIZE}
	local root_size=
	local root_dev= boot_dev= swap_dev=
877
	local bootloader=
878

879 880 881 882 883
	case "$ARCH" in
		ppc64le) bootloader=grub-ieee1275;;
		*) bootloader=syslinux;;
	esac
	init_progs $bootloader || return 1
884 885 886 887 888 889 890 891 892
	confirm_erase $@ || return 1

	if [ -n "$USE_RAID" ]; then
		boot_part_type="fd"
		root_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi
	for diskdev in "$@"; do
893 894 895 896 897 898 899 900 901 902 903 904 905 906 907
		if [ "$ARCH" = "ppc64le" ]; then
			setup_partitions $diskdev \
				"${prep_size}M,$prep_part_type" \
				"${boot_size}M,$boot_part_type,*" \
				"${swap_size}M,$swap_part_type" \
				"${root_size}${root_size:+M},$root_part_type" \
				|| return 1

		else
			setup_partitions $diskdev \
				"${boot_size}M,$boot_part_type,*" \
				"${swap_size}M,$swap_part_type" \
				"${root_size}${root_size:+M},$root_part_type" \
				|| return 1
		fi
908 909 910 911
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@
912

913 914 915 916 917 918 919
	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		root_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
920 921 922 923 924 925 926 927
		local index=
		case "$ARCH" in
			# use the second non botable partition on ppc64le,
			# as PReP partition is the bootable partition
			ppc64le) index=2;;
			*) index=1;;
		esac
		root_dev=$(find_nth_non_boot_parts $index 83 $@)
928
	fi
929

930
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
931
	setup_root $root_dev $BOOT_DEV $@
932 933
}

934
diskselect_help() {
935
	cat <<-__EOF__
936

937 938
		The disk you select can be used for a traditional disk install or for a
		data-only install.
939

940
		The disk will be erased.
941

942
		Enter 'none' if you want to run diskless.
943

944
	__EOF__
945 946
}

947
diskmode_help() {
948
	cat <<-__EOF__
949

950
		You can select between 'sys', 'data', 'lvm', 'lvmsys' or 'lvmdata'.
951

952 953 954
		sys:
		  This mode is a traditional disk install. The following partitions will be
		  created on the disk: /boot, / (filesystem root) and swap.
955

956
		  This mode may be used for development boxes, desktops, virtual servers, etc.
957

958 959 960
		data:
		  This mode uses your disk(s) for data storage, not for the operating system.
		  The system itself will run from tmpfs (RAM).
961

962 963
		  Use this mode if you only want to use the disk(s) for a mailspool, databases,
		  logs, etc.
964

965 966
		lvm:
		  Enable logical volume manager and ask again for 'sys' or 'data'.
967

968 969
		lvmsys:
		  Same as 'sys' but use logical volume manager for partitioning.
970

971 972
		lvmdata:
		  Same as 'data' but use logical volume manager for partitioning.
973

974
	__EOF__
975 976 977 978 979 980 981
}

# ask for a root or data disk
# returns answer in global variable $answer
ask_disk() {
	local prompt="$1"
	local help_func="$2"
982
	local i=
983 984
	shift 2
	answer=
985
	local default_disk=${DEFAULT_DISK:-$1}
986

987 988 989
	while ! all_in_list "$answer" $@ "none" "abort"; do
		echo "Available disks are:"
		show_disk_info "$@"
990 991
		echon "$prompt [$default_disk] "
		default_read answer $default_disk
992 993 994 995
		case "$answer" in
			'abort') exit 0;;
			'none') return 0;;
			'?') $help_func;;
996 997 998 999
			*) for i in $answer; do
				if ! [ -b "/dev/$i" ]; then
					echo "/dev/$i is not a block device" >&2
					answer=
1000
				fi
1001
			done;;
1002 1003 1004 1005
		esac
	done
}

1006
usage() {
1007 1008 1009 1010 1011 1012 1013 1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031 1032 1033
	cat <<-__EOF__
		usage: setup-disk [-hLqrv] [-k kernelflavor] [-m MODE] [-o apkovl] [-s SWAPSIZE]
		                  [MOUNTPOINT | DISKDEV...]

		Install alpine on harddisk.

		If MOUNTPOINT is specified, then do a traditional disk install with MOUNTPOINT
		as root.

		If DISKDEV is specified, then use the specified disk(s) without asking. If
		multiple disks are specified then set them up in a RAID array. If there are
		mode than 2 disks, then use raid level 5 instead of raid level 1.

		options:
		 -h  Show this help
		 -m  Use disk for MODE without asking, where MODE is either 'data' or 'sys'
		 -o  Restore system from given apkovl file
		 -k  Use kernelflavor instead of $KERNEL_FLAVOR
		 -L  Use LVM to manage partitions
		 -q  Exit quietly if no disks are found
		 -r  Enable software raid1 with single disk
		 -s  Use SWAPSIZE MB instead of autodetecting swap size (Use 0 to disable swap)
		 -v  Be more verbose about what is happening

		If BOOTFS, ROOTFS, VARFS are specified, then format a partition with specified
		filesystem. If not specified, the default filesystem is ext4.
		Supported filesystems for
1034
		  boot: ext2, ext3, ext4, btrfs, xfs
1035 1036 1037
		  root: ext2, ext3, ext4, btrfs, xfs
		   var: ext2, ext3, ext4, btrfs, xfs
	__EOF__
1038 1039 1040
	exit 1
}

Francesco Colista's avatar
Francesco Colista committed
1041 1042
kver=$(uname -r)
case $kver in
1043 1044 1045
	*-rc[0-9]*) KERNEL_FLAVOR=vanilla;;
	*-[a-z]*) KERNEL_FLAVOR=${kver##*-};;
	*) KERNEL_FLAVOR=vanilla;;
1046 1047
esac

1048
DISK_MODE=
1049
USE_LVM=
1050
# Parse args
1051
while getopts "hk:Lm:o:qrs:v" opt; do
1052
	case $opt in
1053
		m) DISK_MODE="$OPTARG";;
1054
		k) KERNEL_FLAVOR="$OPTARG";;
1055
		L) USE_LVM="_lvm";;
1056
		o) APKOVL="$OPTARG";;
1057 1058
		q) QUIET=1;;
		r) USE_RAID=1;;
1059
		s) SWAP_SIZE="$OPTARG";;
1060
		v) VERBOSE=1;;
Natanael Copa's avatar
Natanael Copa committed
1061
		*) usage;;
1062 1063
	esac
done
1064
shift $(( $OPTIND - 1))
1065

1066 1067
if [ -d "$1" ]; then
	# install to given mounted root
1068
	apk add --quiet syslinux
1069 1070
	install_mounted_root "${1%/}" \
		&& echo "You might need fix the MBR to be able to boot" >&2
1071 1072 1073
	exit $?
fi

1074 1075 1076 1077 1078 1079 1080 1081 1082 1083
reset_var
swapoff -a

# stop all volume groups in use
vgchange --ignorelockingfailure -a n >/dev/null 2>&1

if [ -n "$USE_RAID" ]; then
	stop_all_raid
fi

1084
disks=$(find_disks)
1085
diskdevs=
Natanael Copa's avatar
Natanael Copa committed
1086 1087

# no disks so lets exit quietly.
1088 1089 1090 1091
if [ -z "$disks" ]; then
	[ -z "$QUIET" ] && echo "No disks found." >&2
	exit 0
fi
Natanael Copa's avatar
Natanael Copa committed
1092

1093
if [ $# -gt 0 ]; then
1094
	# check that they are
1095 1096 1097
	for i in "$@"; do
		j=$(readlink -f "$i" | sed 's:^/dev/::; s:/:!:g')
		if ! [ -e "/sys/block/$j/device" ]; then
1098
			echo "$i is not a suitable for partitioning"
1099 1100
			exit 1
		fi
1101
		diskdevs="$diskdevs /dev/${j//!//}"
1102 1103
	done
else
1104
	ask_disk "Which disk(s) would you like to use? (or '?' for help or 'none')" \
1105
		diskselect_help $disks
1106
	if [ "$answer" != none ]; then
1107 1108 1109
		for i in $answer; do
			diskdevs="$diskdevs /dev/$i"
		done
1110 1111
	else
		DISK_MODE="none"
1112
	fi
1113
fi
Natanael Copa's avatar
Natanael Copa committed
1114

1115
if [ -n "$diskdevs" ] && [ -z "$DISK_MODE" ]; then
1116
	answer=
1117
	disk_is_or_disks_are="disk is"
1118
	it_them="it"
1119
	set -- $diskdevs
1120
	if [ $# -gt 1 ]; then
1121
		disk_is_or_disks_are="disks are"
1122 1123
		it_them="them"
	fi
1124

1125
	while true; do
1126
		echo "The following $disk_is_or_disks_are selected${USE_LVM:+ (with LVM)}:"
1127
		show_disk_info $diskdevs
1128
		_lvm=${USE_LVM:-", 'lvm'"}
1129
		echon "How would you like to use $it_them? ('sys', 'data'${_lvm#_lvm} or '?' for help) [?] "
1130 1131 1132
		default_read answer '?'
		case "$answer" in
		'?') diskmode_help;;
1133
		sys|data) break;;
1134 1135 1136 1137 1138 1139 1140
		lvm) USE_LVM="_lvm" ;;
		nolvm) USE_LVM="";;
		lvmsys|lvmdata)
			answer=${answer#lvm}
			USE_LVM="_lvm"
			break
			;;
1141 1142
		esac
	done
1143
	DISK_MODE="$answer"
1144
fi
Natanael Copa's avatar
Natanael Copa committed
1145

1146 1147 1148 1149
if [ -z "$SWAP_SIZE" ]; then
	SWAP_SIZE=$(find_swap_size $diskdevs)
fi

1150 1151 1152 1153
set -- $diskdevs
if [ $# -gt 1 ]; then
	USE_RAID=1
fi
1154

1155 1156
dmesg -n1

1157
# native disk install
1158
case "$DISK_MODE" in
1159
sys) native_disk_install$USE_LVM $diskdevs;;
1160
data) data_only_disk_install$USE_LVM $diskdevs;;
1161
none) exit 0;;
1162
*) echo "Not a valid install mode: $DISK_MODE" >&2; exit 1;;
1163
esac
Natanael Copa's avatar
Natanael Copa committed
1164

1165
RC=$?
1166
echo "$DISK_MODE" > /tmp/alpine-install-diskmode.out
1167